!     
!     CalculiX - A 3-dimensional finite element program
!     Copyright (C) 1998-2007 Guido Dhondt
!     
!     This program is free software; you can redistribute it and/or
!     modify it under the terms of the GNU General Public License as
!     published by the Free Software Foundation(version 2);
!     
!     
!     This program is distributed in the hope that it will be useful,
!     but WITHOUT ANY WARRANTY; without even the implied warranty of 
!     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
!     GNU General Public License for more details.
!     
!     You should have received a copy of the GNU General Public License
!     along with this program; if not, write to the Free Software
!     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!     
!    construction of the B matrix      
!     
      subroutine resultgas(itg,ieg,ntg,ntm,
     &     bc,nload,sideload,nelemload,xloadact,lakon,ntmat_,
     &     voldgas,shcon,nshcon,ipkon,kon,co,nflow,ikboun,xbounact,
     &     nboun,iinc,istep,dtime,ttime,time,ilboun,ndirboun,nodeboun,
     &     ikforc,ilforc,xforcact,nforc,ielmat,nteq,prop,ielprop,
     &     nactdog,nacteq,iin,physcon,camt,camf,camp,rhcon,nrhcon,
     &     ipobody,ibody,xbodyact,nbody,dtheta)
!     
      implicit none
!     
      logical identity
      character*8 lakonl,lakon(*)
      character*20 sideload(*)
!     
      integer itg(*),ieg(*),ntg,nteq,nflow,nload,ielmat(*),iflag,
     &     nelemload(2,*),nope,nopes,mint2d,i,j,k,l,nrhcon(*),
     &     node,imat,ntmat_,id,ntm,ifaceq(8,6),ifacet(6,4),numf,
     &     ifacew(8,5),node1,node2,nshcon(*),nelem,ig,index,konl(20),
     &     ipkon(*),kon(*),ikboun(*),nboun,ndirboun(*),nodeboun(*),idof,
     &     iinc,istep,jltyp,nfield,ilboun(*),ikforc(*),ipobody(2,*),
     &     ilforc(*),nforc,nodem,idirf(5),ieq,nactdog(0:3,*),nbody,
     &     nacteq(0:3,*),ielprop(*),nodef(5),iin,kflag,ibody(3,*)
!   
      real*8 bc(ntm),xloadact(2,*),cp,h(2),physcon(3),r,dvi,rho,
     &     xl2(0:3,8),coords(3),dxsj2,temp,xi,et,weight,xsj2(3),
     &     gastemp,voldgas(0:3,*),shcon(0:3,ntmat_,*),co(3,*),shp2(4,8),
     &     xbounact(*),field,prop(*),tg1,tg2,dtime,ttime,time,g(3),
     &     xforcact(*),areaj,xflow,tvar(2),f,df(5),camt,camf,camp,
     &     rhcon(0:1,ntmat_,*),xbodyact(7,*),tf,kappa,a,T,Tt,Pt,
     &     M,dtheta,Ts1,Ts2,xs2(3,2)
!     
      real*8 gauss2d1(2,1),gauss2d2(2,4),gauss2d3(2,9),gauss2d4(2,1),
     &     gauss2d5(2,3),gauss3d1(3,1),gauss3d2(3,8),gauss3d3(3,27),
     &     gauss3d4(3,1),gauss3d5(3,4),gauss3d6(3,15),gauss3d7(3,2),
     &     gauss3d8(3,9),gauss3d9(3,18),weight2d1(1),weight2d2(4),
     &     weight2d3(9),weight2d4(1),weight2d5(3),weight3d1(1),
     &     weight3d2(8),weight3d3(27),weight3d4(1),weight3d5(4),
     &     weight3d6(15),weight3d7(2),weight3d8(9),weight3d9(18)
!     
      include "gauss.f"
!     
      data ifaceq /4,3,2,1,11,10,9,12,
     &     5,6,7,8,13,14,15,16,
     &     1,2,6,5,9,18,13,17,
     &     2,3,7,6,10,19,14,18,
     &     3,4,8,7,11,20,15,19,
     &     4,1,5,8,12,17,16,20/
      data ifacet /1,3,2,7,6,5,
     &     1,2,4,5,9,8,
     &     2,3,4,6,10,9,
     &     1,4,3,8,10,7/
      data ifacew /1,3,2,9,8,7,0,0,
     &     4,5,6,10,11,12,0,0,
     &     1,2,5,4,7,14,10,13,
     &     2,3,6,5,8,15,11,14,
     &     4,6,3,1,12,15,9,13/
      data iflag /2/
!
      kflag=2
!
      tvar(1)=time
      tvar(2)=ttime+dtime
!
!     calculating the maximum change in the solution
!
      camt=0.d0
      camf=0.d0
      camp=0.d0
!
      do i=1,ntg
         node=itg(i)
         do j=0,2
            if(nactdog(j,node).eq.0) cycle
            idof=nactdog(j,node)
            if(j.eq.0) then
               if(dabs(bc(idof)).gt.camt) camt=dabs(bc(idof))
            elseif(j.eq.1) then
               if(dabs(bc(idof)).gt.camf) camf=dabs(bc(idof))
            else
               if(dabs(bc(idof)).gt.camp) camp=dabs(bc(idof))
            endif
         enddo
      enddo
!     
!     updating voldgas
!     
      do i=1,ntg
         node=itg(i)
         do j=0,2
            if(nactdog(j,node).eq.0) cycle
            voldgas(j,node)=voldgas(j,node)+bc(nactdog(j,node))*dtheta
         enddo
      enddo
!
!     testing the validity of the pressures
!
      do i=1,ntg
         node=itg(i)
         if(voldgas(2,node).lt.0) then
            iin=0
            return
         endif
      enddo
!
!     testing the agreement between pressures and massflows
!
c      do i=1,nflow
c         nelem=ieg(i)
c         index=ipkon(nelem)
c         node1=kon(index+1)
c         nodem=kon(index+2)
c         node2=kon(index+3)
c         if((node1.eq.0).or.(node2.eq.0)) cycle
c         if((voldgas(1,nodem).gt.0d0)
c     &        .and.(voldgas(2,node1).lt.voldgas(2,node2))) then
cc            write(*,*)'xflow',voldgas(1,nodem)
cc            write(*,*) 'P1',voldgas(2,node1)
cc            write(*,*) 'P2',voldgas(2,node2)
c            iin=0
c            return
c         endif
c         if((voldgas(1,nodem).lt.0d0)
c     &        .and.(voldgas(2,node1).gt.voldgas(2,node2))) then
cc            write(*,*)'xflow',voldgas(1,nodem)
cc            write(*,*) 'P1',voldgas(2,node1)
cc            write(*,*) 'P2',voldgas(2,node2)
c            iin=0
c            return
c         endif
c      enddo
!     
!     iteratively solving Tt=T+0.5*v**2/(2*Cp) to obtain Ts
!      
      do i=1,ntg
          node=itg(i)
          nelem=nactdog(3,node)
!          
          if(nelem.gt.0) then
!     
             nodem=kon(ipkon(nelem)+2)
             T=voldgas(3,node)
             Tt=voldgas(0,node)
             Pt=voldgas(2,node)
             xflow=voldgas(1,nodem)
!     
            imat=ielmat(nelem)
            call materialdata_tg(imat,ntmat_,voldgas(3,node),
     &           shcon,nshcon,cp,r,dvi,rhcon,nrhcon,rho)
!     
            index=ielprop(nelem)
            kappa=(cp/(cp-R))
            A=prop(index+1)
!    
            call Ts_calc(xflow,Tt,Pt,kappa,r,a,T)
!
            voldgas(3,node)=T
            M=(2.d0/(kappa-1.d0)*(Tt/voldgas(3,node)-1.d0))**0.5d0
         endif
      enddo
!
!     reinitialisation of the Bc matrix
!
      do i=1,nteq
         bc(i)=0.d0
      enddo
!
!     determining the residual
!
      do i=1,nflow
         nelem=ieg(i)
         index=ipkon(nelem)
         node1=kon(index+1)
         nodem=kon(index+2)
         node2=kon(index+3)
         xflow=voldgas(1,nodem)
!
         if(node1.eq.0) then
            tg1=voldgas(0,node2)
            tg2=tg1
            Ts1=voldgas(3,node2)
            Ts2=Ts1
         elseif(node2.eq.0) then
            tg1=voldgas(0,node1)
            tg2=tg1
            ts1=voldgas(3,node1)
            Ts2=Ts1
         else
            tg1=voldgas(0,node1)
            tg2=voldgas(0,node2)
            Ts1=voldgas(3,node1)
            ts2=voldgas(3,node2)
         endif
         gastemp=(ts1+ts2)/2.d0
!     
         imat=ielmat(nelem)
!         
         call materialdata_tg(imat,ntmat_,gastemp,shcon,nshcon,cp,r,dvi,
     &        rhcon,nrhcon,rho)
! 
         if(node1.ne.0) then
!     
!           energy equation contribution node1
!     
            if (nacteq(0,node1).ne.0) then
               ieq=nacteq(0,node1)
               if (xflow.lt.0d0)then
                  bc(ieq)=bc(ieq)+cp*(tg1-tg2)*xflow
               endif
            endif
!     
!           mass equation contribution node1
!    
            if (nacteq(1,node1).ne.0) then
               ieq=nacteq(1,node1)
               bc(ieq)=bc(ieq)-xflow
            endif
         endif
! 
         if(node2.ne.0) then
!     
!           energy equation contribution node2
!     
            if (nacteq(0,node2).ne.0) then
               ieq=nacteq(0,node2)
               if (xflow.gt.0d0)then
                  bc(ieq)=bc(ieq)-cp*(tg2-tg1)*xflow
               endif
            endif
!     
!           mass equation contribution node2
!     
            if (nacteq(1,node2).ne.0) then
!               
               ieq=nacteq(1,node2)
               bc(ieq)=bc(ieq)+xflow
            endif
         endif
!     
!     element equation
!
         if (nacteq(2,nodem).ne.0) then
            ieq=nacteq (2,nodem)
!
!           for liquids: determine the gravity vector
!
            if(lakon(nelem)(2:3).eq.'LI') then
               do j=1,3
                  g(j)=0.d0
               enddo
               if(nbody.gt.0) then
                  index=nelem
                  do
                     j=ipobody(1,index)
                     if(j.eq.0) exit
                     if(ibody(1,j).eq.2) then
                        g(1)=g(1)+xbodyact(1,j)*xbodyact(2,j)
                        g(2)=g(2)+xbodyact(1,j)*xbodyact(3,j)
                        g(3)=g(3)+xbodyact(1,j)*xbodyact(4,j)
                     endif
                     index=ipobody(2,index)
                     if(index.eq.0) exit
                  enddo
               endif
            endif
!
            call flux(node1,node2,nodem,nelem,lakon,kon,ipkon,
     &           nactdog,identity,
     &           ielprop,prop,kflag,voldgas,xflow,f,nodef,idirf,df,
     &           cp,r,rho,physcon,g,co,dvi,numf)
            bc(ieq)=-f
         endif
      enddo
!     
!     convection with the walls
!    
      do i=1,nload
         if(sideload(i)(3:4).eq.'FC') then
            nelem=nelemload(1,i)
            lakonl=lakon(nelem)
            node=nelemload(2,i)
            ieq=nacteq(0,node)
            if(ieq.eq.0) then 
               cycle
            endif
!     
            call nident(itg,node,ntg,id)
!     
!     calculate the area
!     
            read(sideload(i)(2:2),'(i1)') ig
!     
!     number of nodes and integration points in the face
!     
            if(lakonl(4:4).eq.'2') then
               nope=20
               nopes=8
            elseif(lakonl(4:4).eq.'8') then
               nope=8
               nopes=4
            elseif(lakonl(4:5).eq.'10') then
               nope=10
               nopes=6
            elseif(lakonl(4:4).eq.'4') then
               nope=4
               nopes=3
            elseif(lakonl(4:5).eq.'15') then
               nope=15
            else
               nope=6
            endif
!     
            if(lakonl(4:5).eq.'8R') then
               mint2d=1
            elseif((lakonl(4:4).eq.'8').or.(lakonl(4:6).eq.'20R'))
     &              then
               if(lakonl(7:7).eq.'A') then
                  mint2d=2
               else
                  mint2d=4
               endif
            elseif(lakonl(4:4).eq.'2') then
               mint2d=9
            elseif(lakonl(4:5).eq.'10') then
               mint2d=3
            elseif(lakonl(4:4).eq.'4') then
               mint2d=1
            endif
!     
            if(lakonl(4:4).eq.'6') then
               mint2d=1
               if(ig.le.2) then
                  nopes=3
               else
                  nopes=4
               endif
            endif
            if(lakonl(4:5).eq.'15') then
               if(ig.le.2) then
                  mint2d=3
                  nopes=6
               else
                  mint2d=4
                  nopes=8
               endif
            endif
!     
!     connectivity of the element
!     
            index=ipkon(nelem)
            if(index.lt.0) then
               write(*,*) '*ERROR in radflowload: element ',nelem
               write(*,*) '       is not defined'
               stop
            endif
            do k=1,nope
               konl(k)=kon(index+k)
            enddo
!     
!     coordinates of the nodes belonging to the face
!     
            if((nope.eq.20).or.(nope.eq.8)) then
               do k=1,nopes
                  xl2(0,k)=voldgas(0,konl(ifaceq(k,ig)))
                  do j=1,3
                     xl2(j,k)=co(j,konl(ifaceq(k,ig)))+
     &                    voldgas(j,konl(ifaceq(k,ig)))
                  enddo
               enddo
            elseif((nope.eq.10).or.(nope.eq.4)) then
               do k=1,nopes
                  xl2(0,k)=voldgas(0,konl(ifacet(k,ig)))
                  do j=1,3
                     xl2(j,k)=co(j,konl(ifacet(k,ig)))+
     &                    voldgas(j,konl(ifacet(k,ig)))
                  enddo
               enddo
            else
               do k=1,nopes
                  xl2(0,k)=voldgas(0,konl(ifacew(k,ig)))
                  do j=1,3
                     xl2(j,k)=co(j,konl(ifacew(k,ig)))+
     &                    voldgas(j,konl(ifacew(k,ig)))
                  enddo
               enddo
            endif
!     
!     integration to obtain the area and the mean
!     temperature
!     
            do l=1,mint2d
               if((lakonl(4:5).eq.'8R').or.
     &              ((lakonl(4:4).eq.'6').and.(nopes.eq.4))) then
                  xi=gauss2d1(1,l)
                  et=gauss2d1(2,l)
                  weight=weight2d1(l)
               elseif((lakonl(4:4).eq.'8').or.
     &                 (lakonl(4:6).eq.'20R').or.
     &                 ((lakonl(4:5).eq.'15').and.(nopes.eq.8))) then
                  xi=gauss2d2(1,l)
                  et=gauss2d2(2,l)
                  weight=weight2d2(l)
               elseif(lakonl(4:4).eq.'2') then
                  xi=gauss2d3(1,l)
                  et=gauss2d3(2,l)
                  weight=weight2d3(l)
               elseif((lakonl(4:5).eq.'10').or.
     &                 ((lakonl(4:5).eq.'15').and.(nopes.eq.6))) then
                  xi=gauss2d5(1,l)
                  et=gauss2d5(2,l)
                  weight=weight2d5(l)
               elseif((lakonl(4:4).eq.'4').or.
     &                 ((lakonl(4:4).eq.'6').and.(nopes.eq.3))) then
                  xi=gauss2d4(1,l)
                  et=gauss2d4(2,l)
                  weight=weight2d4(l)
               endif
!     
               if(nopes.eq.8) then
                  call shape8q(xi,et,xl2,xsj2,xs2,shp2,iflag)
               elseif(nopes.eq.4) then
                  call shape4q(xi,et,xl2,xsj2,xs2,shp2,iflag)
               elseif(nopes.eq.6) then
                  call shape6tri(xi,et,xl2,xsj2,xs2,shp2,iflag)
               else
                  call shape3tri(xi,et,xl2,xsj2,xs2,shp2,iflag)
               endif
!     
               dxsj2=dsqrt(xsj2(1)*xsj2(1)+xsj2(2)*xsj2(2)+
     &              xsj2(3)*xsj2(3))
               areaj=dxsj2*weight
!     
               temp=0.d0
               do k=1,3
                  coords(k)=0.d0
               enddo
               do j=1,nopes
                  temp=temp+xl2(0,j)*shp2(4,j)
                  do k=1,3
                     coords(k)=coords(k)+xl2(k,j)*shp2(4,j)
                  enddo
               enddo
!     
               if(sideload(i)(5:6).ne.'NU') then
                  h(1)=xloadact(1,i)
               else
                  read(sideload(i)(2:2),'(i1)') jltyp
                  jltyp=jltyp+10
                  tf=voldgas(0,node)
                  call film(h,tf,temp,istep,
     &                 iinc,tvar,nelem,l,coords,jltyp,field,nfield,
     &                 sideload(i),node,areaj,voldgas)
               endif
               if(lakonl(5:7).eq.'0RA') then
                  bc(ieq)=bc(ieq)+
     &             2.d0*(temp-voldgas(0,node))*h(1)*dxsj2*weight
               else
                  bc(ieq)=bc(ieq)+
     &                 (temp-voldgas(0,node))*h(1)*dxsj2*weight
               endif
            enddo
         endif
      enddo
!     
!     prescribed heat generation        
!     
      do i=1,ntg
         node=itg(i)
         idof=7*(node-1)
         call nident(ikforc,idof,nforc,id)
         if(id.gt.0) then
            if(ikforc(id).eq.idof) then
               ieq=nacteq(0,node)
               bc(ieq)=bc(ieq)+xforcact(ilforc(id))
               cycle
            endif
         endif
      enddo
!
      return
      end
